'---------------------------------------------------------------------------------------
' Library: SlxManagedLib - Managed wrapper for SalesLogix API
'          2001 Ryan Farley - Customer FX Corporation
'--------------------------------------------------------------------------------------- 

Imports System.Runtime.InteropServices

Public Class SlgxApi

#Region "Database Access Functions"
    '---------------------------------------------------------------------------------------
    ' Database Access Functions
    '---------------------------------------------------------------------------------------    
    <DllImport("SlgxApi.dll", EntryPoint:="slapi_Login")> Public Shared Function Login(ByVal Username As String, ByVal Password As String) As Short
    End Function

    <DllImport("SlgxApi.dll", EntryPoint:="slapi_LogInto")> Public Shared Function LogInto(ByVal Database As String, ByVal Username As String, ByVal Password As String) As Short
    End Function

    <DllImport("SlgxApi.dll", EntryPoint:="slapi_LogOff")> Public Shared Function LogOff() As Short
    End Function

    <DllImport("SlgxApi.dll", EntryPoint:="slapi_LoggedIn")> Public Shared Function LoggedIn() As Byte
    End Function

    <DllImport("SlgxApi.dll", EntryPoint:="slapi_slapi_SetKeyFileName")> Public Shared Function SetKeyFileName(ByVal FileName As String) As Short
    End Function

#End Region

#Region "Table Access Functions"
    '---------------------------------------------------------------------------------------
    ' Table Access Functions
    '--------------------------------------------------------------------------------------- 

    <DllImport("SlgxApi.dll", EntryPoint:="slapi_DBOpenTable")> Public Shared Function DBOpenTable(ByVal Table As String, ByVal ReadOnlyByte As Byte) As Integer
    End Function

    <DllImport("SlgxApi.dll", EntryPoint:="slapi_DBOpenTableFromDatabase")> Public Shared Function DBOpenTableFromDatabase(ByVal Database As String, ByVal Table As String, ByVal ReadOnlyByte As Byte) As Integer
    End Function

    <DllImport("SlgxApi.dll", EntryPoint:="slapi_DBOpenTableFromDatabaseFor")> Public Shared Function DBOpenTableFromDatabaseFor(ByVal Database As String, ByVal Username As String, ByVal Password As String, ByVal Table As String, ByVal ReadOnlyByte As Byte) As Integer
    End Function

    <DllImport("SlgxApi.dll", EntryPoint:="slapi_DBExecuteSQL")> Public Shared Function DBExecuteSQL(ByVal Query As String) As Short
    End Function

    <DllImport("SlgxApi.dll", EntryPoint:="slapi_DBExecuteSQLOnDatabase")> Public Shared Function DBExecuteSQLOnDatabase(ByVal Database As String, ByVal Query As String) As Short
    End Function

    <DllImport("SlgxApi.dll", EntryPoint:="slapi_DBExecuteSQLOnDatabaseFor")> Public Shared Function DBExecuteSQLOnDatabaseFor(ByVal Database As String, ByVal Username As String, ByVal Password As String, ByVal Query As String) As Short
    End Function

    <DllImport("SlgxApi.dll", EntryPoint:="slapi_DBOpenSQL")> Public Shared Function DBOpenSQL(ByVal Query As String, ByVal ReadOnlyByte As Byte) As Integer
    End Function

    <DllImport("SlgxApi.dll", EntryPoint:="slapi_DBOpenSQLFromDatabase")> Public Shared Function DBOpenSQLFromDatabase(ByVal Database As String, ByVal Code As String, ByVal ReadOnlyByte As Byte) As Integer
    End Function

    <DllImport("SlgxApi.dll", EntryPoint:="slapi_DBOpenSQLFromDatabaseFor")> Public Shared Function DBOpenSQLFromDatabaseFor(ByVal Database As String, ByVal Username As String, ByVal Password As String, ByVal Query As String, ByVal ReadOnlyByte As Byte) As Integer
    End Function

    <DllImport("SlgxApi.dll", EntryPoint:="slapi_DBReset")> Public Shared Function DBReset() As Short
    End Function

    <DllImport("SlgxApi.dll", EntryPoint:="slapi_DBClose")> Public Shared Function DBClose(ByVal Handle As Integer) As Short
    End Function

    <DllImport("SlgxApi.dll", EntryPoint:="slapi_DBCloseAll")> Public Shared Function DBCloseAll() As Short
    End Function

    <DllImport("SlgxApi.dll", EntryPoint:="slapi_DBGetPrimaryKeyFieldFor")> Public Shared Function DBGetPrimaryKeyFieldFor(ByVal Table As String) As String
    End Function

#End Region

#Region "Table Functions"
    '---------------------------------------------------------------------------------------
    ' Table Functions
    '--------------------------------------------------------------------------------------- 
    <DllImport("SlgxApi.dll", EntryPoint:="slapi_DBLocate")> Public Shared Function DBLocate(ByVal Handle As Integer, ByVal Field As String, ByVal ID As String) As Byte
    End Function

    <DllImport("SlgxApi.dll", EntryPoint:="slapi_DBLocateOptions")> Public Shared Function DBLocateOptions(ByVal Handle As Integer, ByVal NoCase As Byte, ByVal Partial As Byte) As Short
    End Function

    <DllImport("SlgxApi.dll", EntryPoint:="slapi_DBGetKeyField")> Public Shared Function DBGetKeyField(ByVal Handle As Integer) As String
    End Function

    <DllImport("SlgxApi.dll", EntryPoint:="slapi_DBSetKeyField")> Public Shared Function DBSetKeyField(ByVal Handle As Integer, ByVal Field As String) As Short
    End Function

    <DllImport("SlgxApi.dll", EntryPoint:="slapi_DBGetSecuredWhereFor")> Public Shared Function DBGetSecuredWhereFor(ByVal Table As String) As String
    End Function

    <DllImport("SlgxApi.dll", EntryPoint:="slapi_DBRecordCount")> Public Shared Function DBRecordCount(ByVal Handle As Integer) As Integer
    End Function

#End Region

#Region "Row Functions"
    '---------------------------------------------------------------------------------------
    ' Row Functions
    '--------------------------------------------------------------------------------------- 

    <DllImport("SlgxApi.dll", EntryPoint:="slapi_DBBOF")> Public Shared Function BOF(ByVal Handle As Integer) As Byte
    End Function

    <DllImport("SlgxApi.dll", EntryPoint:="slapi_DBEOF")> Public Shared Function EOF(ByVal Handle As Integer) As Byte
    End Function

    <DllImport("SlgxApi.dll", EntryPoint:="slapi_DBCancel")> Public Shared Function DBCancel(ByVal Handle As Integer) As Short
    End Function

    <DllImport("SlgxApi.dll", EntryPoint:="slapi_DBClearValue")> Public Shared Function DBClearValue(ByVal Handle As Integer, ByVal Field As String) As Short
    End Function

    <DllImport("SlgxApi.dll", EntryPoint:="slapi_DBClearValueByIndex")> Public Shared Function DBClearValueByIndex(ByVal Handle As Integer, ByVal FieldIndex As Integer) As Short
    End Function

    <DllImport("SlgxApi.dll", EntryPoint:="slapi_DBCreateIDFor")> Public Shared Function DBCreateIDFor(ByVal Table As String) As String
    End Function

    <DllImport("SlgxApi.dll", EntryPoint:="slapi_DBDeleteCurrentRecord")> Public Shared Function DBDeleteCurrentRecord(ByVal Handle As Integer) As Short
    End Function

    <DllImport("SlgxApi.dll", EntryPoint:="slapi_DBEdit")> Public Shared Function DBEdit(ByVal Handle As Integer) As Short
    End Function

    <DllImport("SlgxApi.dll", EntryPoint:="slapi_DBFieldSize")> Public Shared Function DBFieldSize(ByVal Handle As Integer, ByVal Field As String) As Integer
    End Function

    <DllImport("SlgxApi.dll", EntryPoint:="slapi_DBFieldSizeByIndex")> Public Shared Function DBFieldSizeByIndex(ByVal Handle As Integer, ByVal Index As Integer) As Integer
    End Function

    <DllImport("SlgxApi.dll", EntryPoint:="slapi_DBGetValue")> Public Shared Function DBGetValue(ByVal Handle As Integer, ByVal Field As String) As String
    End Function

    <DllImport("SlgxApi.dll", EntryPoint:="slapi_DBGetValueByIndex")> Public Shared Function DBGetValueByIndex(ByVal Handle As Integer, ByVal Index As Integer) As String
    End Function

    <DllImport("SlgxApi.dll", EntryPoint:="slapi_DBGoodData")> Public Shared Function DBGoodData(ByVal Handle As Integer, ByVal Data As String) As Byte
    End Function

    <DllImport("SlgxApi.dll", EntryPoint:="slapi_DBInsert")> Public Shared Function DBInsert(ByVal Handle As Integer) As Short
    End Function

    <DllImport("SlgxApi.dll", EntryPoint:="slapi_DBKeyGetValue")> Public Shared Function DBKeyGetValue(ByVal Handle As Integer, ByVal ID As String, ByVal Field As String) As String
    End Function

    <DllImport("SlgxApi.dll", EntryPoint:="slapi_DBKeyGetValueByIndex")> Public Shared Function DBKeyGetValueByIndex(ByVal Handle As Integer, ByVal ID As String, ByVal Index As Integer) As String
    End Function

    <DllImport("SlgxApi.dll", EntryPoint:="slapi_DBKeyLocate")> Public Shared Function DBKeyLocate(ByVal Handle As Integer, ByVal ID As String) As Byte
    End Function

    <DllImport("SlgxApi.dll", EntryPoint:="slapi_DBMoveTo")> Public Shared Function DBMoveTo(ByVal Handle As Integer, ByVal Direction As String) As String
    End Function

    <DllImport("SlgxApi.dll", EntryPoint:="slapi_DBPost")> Public Shared Function DBPost(ByVal Handle As Integer) As Short
    End Function

    <DllImport("SlgxApi.dll", EntryPoint:="slapi_DBSetValue")> Public Shared Function DBSetValue(ByVal Handle As Integer, ByVal Field As String, ByVal Value As String) As Short
    End Function

    <DllImport("SlgxApi.dll", EntryPoint:="slapi_DBSetValueByIndex")> Public Shared Function DBSetValueByIndex(ByVal Handle As Integer, ByVal FieldIndex As Integer, ByVal Value As String) As Short
    End Function

    <DllImport("SlgxApi.dll", EntryPoint:="slapi_DBValueIsNull")> Public Shared Function DBValueIsNull(ByVal Handle As Integer, ByVal Field As String) As Byte
    End Function

    <DllImport("SlgxApi.dll", EntryPoint:="slapi_DBValueIsNullByIndex")> Public Shared Function DBValueIsNullByIndex(ByVal Handle As Integer, ByVal FieldIndex As Integer) As Byte
    End Function

    <DllImport("SlgxApi.dll", EntryPoint:="slapi_DBInTransaction")> Public Shared Function DBInTransaction(ByVal Handle As Integer) As Byte
    End Function

    <DllImport("SlgxApi.dll", EntryPoint:="slapi_DBStartTransaction")> Public Shared Function DBStartTransaction(ByVal Handle As Integer) As Short
    End Function

    <DllImport("SlgxApi.dll", EntryPoint:="slapi_DBRollbackTransaction")> Public Shared Function DBRollbackTransaction(ByVal Handle As Integer) As Short
    End Function

    <DllImport("SlgxApi.dll", EntryPoint:="slapi_DBCommitTransaction")> Public Shared Function DBCommitTransaction(ByVal Handle As Integer) As Short
    End Function

#End Region

#Region "Logging Functions"
    '---------------------------------------------------------------------------------------
    ' Logging Functions
    '--------------------------------------------------------------------------------------- 
    <DllImport("SlgxApi.dll", EntryPoint:="slapi_LogSetGlobalID")> Public Shared Function LogSetGlobalID(ByVal ID As String) As Short
    End Function

    <DllImport("SlgxApi.dll", EntryPoint:="slapi_LogClearGlobalID")> Public Shared Function LogClearGlobalID() As Short
    End Function

    <DllImport("SlgxApi.dll", EntryPoint:="slapi_LogWhatsNewInsert")> Public Shared Function LogWhatsNewInsert(ByVal Type As String, ByVal ID As String) As Short
    End Function

    <DllImport("SlgxApi.dll", EntryPoint:="slapi_LogWhatsNewUpdate")> Public Shared Function LogWhatsNewUpdate(ByVal Type As String, ByVal ID As String, ByVal Datapath As String, ByVal OldValue As String, ByVal NewValue As String) As Short
    End Function

    <DllImport("SlgxApi.dll", EntryPoint:="slapi_LogWhatsNewDocSend")> Public Shared Function LogWhatsNewDocSend(ByVal GlobalID As String, ByVal Key As String, ByVal Description As String, ByVal FileName As String) As Short
    End Function

    <DllImport("SlgxApi.dll", EntryPoint:="slapi_LogSendFileAttachment")> Public Shared Function LogSendFileAttachment(ByVal AccountID As String, ByVal FileName As String) As Short
    End Function

    <DllImport("SlgxApi.dll", EntryPoint:="slapi_LogUpdateFileAttachment")> Public Shared Function LogUpdateFileAttachment(ByVal AccountID As String, ByVal FileName As String) As Short
    End Function

    <DllImport("SlgxApi.dll", EntryPoint:="slapi_LogSendFileAttachmentByID")> Public Shared Function LogSendFileAttachmentByID(ByVal AttachmentID As String) As Short
    End Function

    <DllImport("SlgxApi.dll", EntryPoint:="slapi_LogUpdateFileAttachmentByID")> Public Shared Function LogUpdateFileAttachmentByID(ByVal AttachmentID As String) As Short
    End Function

    <DllImport("SlgxApi.dll", EntryPoint:="slapi_SubscribeToAccount")> Public Shared Function SubscribeToAccount(ByVal AccountID As String, ByVal UserID As String) As Short
    End Function

    <DllImport("SlgxApi.dll", EntryPoint:="slapi_UnSubscribeFromAccount")> Public Shared Function UnSubscribeFromAccount(ByVal AccountID As String, ByVal UserID As String) As Short
    End Function

#End Region

#Region "Error Handling Functions"

    '---------------------------------------------------------------------------------------
    ' Error Handling Functions
    '--------------------------------------------------------------------------------------- 
    <DllImport("SlgxApi.dll", EntryPoint:="slapi_LogixErrors")> Public Shared Function LogixErrors() As Byte
    End Function

    <DllImport("SlgxApi.dll", EntryPoint:="slapi_LogixErrorText")> Public Shared Function LogixErrorText() As String
    End Function

    <DllImport("SlgxApi.dll", EntryPoint:="slapi_LogixErrorCode")> Public Shared Function LogixErrorCode() As Short
    End Function

    <DllImport("SlgxApi.dll", EntryPoint:="slapi_LogixClearError")> Public Shared Function LogixClearError() As Short
    End Function

    <DllImport("SlgxApi.dll", EntryPoint:="slapi_LogixSetError")> Public Shared Function LogixSetError(ByVal Code As Short, ByVal Text As String) As Short
    End Function

#End Region

#Region "Miscellaneous Functions"

    '---------------------------------------------------------------------------------------
    ' Miscellaneous Functions
    '--------------------------------------------------------------------------------------- 

    <DllImport("SlgxApi.dll", EntryPoint:="slapi_GetUserID")> Public Shared Function GetUserID() As String
    End Function

    <DllImport("SlgxApi.dll", EntryPoint:="slapi_GetDefaultSecCodeID")> Public Shared Function GetDefaultSecCodeID() As String
    End Function

    <DllImport("SlgxApi.dll", EntryPoint:="slapi_GetDefaultAreaCode")> Public Shared Function GetDefaultAreaCode() As String
    End Function

    <DllImport("SlgxApi.dll", EntryPoint:="slapi_ParseName")> Public Shared Function ParseName(ByVal Name As String) As String
    End Function

    <DllImport("SlgxApi.dll", EntryPoint:="slapi_Version")> Public Shared Function Version() As Integer
    End Function

#End Region

End Class
